#include <BitBang_I2C.h>

#define SDA_PIN 18
#define SCL_PIN 19
#define RST_PIN 20 // an external 10k pulldown resistor is needed!

BBI2C bbi2c;

int i;

void setup() {
  delay(2000);
  Serial.begin(115200);
  pinMode (RST_PIN, OUTPUT);
  digitalWrite(RST_PIN, HIGH);
  delay(1000);
  bbi2c.bWire = 0; // use bit bang, not wire library
  bbi2c.iSDA = SDA_PIN;
  bbi2c.iSCL = SCL_PIN;
  I2CInit(&bbi2c, 15000L);
  delay(3);
  for (i = 1; i <= 12; i++) {
    i2c_transfer(0b000000000000100110000001); // 0x00, 0x09, 0x81
    i2c_transfer(0b000100000001111101100101); // 0x10, 0x1f, 0x65
    i2c_transfer(0b001000000000000000000000); // 0x20, 0x00, 0x00
    delay(3);
  }
}

void i2c_transfer(uint32_t value) {
  byte buf[3];
  buf[0] = (value >> 16) & 0xFF;
  buf[1] = (value >> 8) & 0xFF;
  buf[2] = value & 0xFF;
  bool success = 0;
  while (!success) {
    Serial.print(i);
    Serial.print(" ");
    Serial.print("sending: ");
    Serial.print(buf[0], HEX);
    Serial.print(" ");
    Serial.print(buf[1], HEX);
    Serial.print(" ");
    Serial.print(buf[2], HEX);
    Serial.print(" ");
    int bytes_written = I2CWrite(&bbi2c, 0b0000000, buf, sizeof buf);
    if (bytes_written == 0) {
      Serial.println("error!");
    } else {
      Serial.print("success: ");
      Serial.print(bytes_written);
      Serial.println(" bytes written");
      success = 1;
    }
    delay(1);
  }
}

void loop() {}
